package il.ac.tau.cs.sw1.maxspan;

import java.util.Arrays;

public class MaxSpan {

	public static int maxSpan(int[] nums) {
		int maxspan = 0;
		for (int value : values(nums)){
			maxspan = Math.max(maxspan, span(value, nums));
		}
		return maxspan;
	}

	private static int span(int value, int[] nums) {
		return lastIndexOf(value, nums) - firstIndexOf(value, nums) + 1;
	}

	private static int lastIndexOf(int value, int[] nums) {
		for (int i = nums.length - 1; i >= 0; i--) {
			if (nums[i] == value) {
				return i;
			}
		}
		return -1;
	}

	private static int firstIndexOf(int value, int[] nums) {
		for (int i = 0; i < nums.length; i++) {
			if (nums[i] == value) {
				return i;
			}
		}
		return -1;
	}

	private static int[] values(int[] nums) {
		int[] values = new int[nums.length];
		int current = 0;
		
		for (int i = 0; i < nums.length; i++) {
			if (!contains(values, current, nums[i])) {
				add(values, current++, nums[i]);
			}
		}
		return Arrays.copyOf(values, current);
	}

	private static void add(int[] values, int position, int value) {
		values[position] = value;
	}

	private static boolean contains(int[] values, int current, int value) {
		for (int i = 0; i < current; i++) {
			if (values[i] == value) {
				return true;
			}
		}
		return false;
	}

}
